stages:
- update
- test
- updateSuper

update:     # runs pipeline as scheduled: https://gitlab.com/FelixFranz/FHWS/smart-contract-generation/generator.backend/pipeline_schedules
  stage: update
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  before_script:
  - mkdir -p ~/.ssh
  # install ssh key for public key
  - ssh-keyscan gitlab.com >> ~/.ssh/known_hosts
  - echo -e $GITLAB_CI_DEPLOY_KEY > ~/.ssh/id_rsa
  - chmod 700 ~/.ssh/id_rsa
  # remove token from git repository url
  - export CI_PUSH_REPO=$(echo "git@gitlab.com:"$(echo $CI_REPOSITORY_URL | grep -oP "^.*:\/\/.+:.+@gitlab.com/\K(.+)$") )
  - echo "CI_PUSH_REPO=$CI_PUSH_REPO"
  - git remote set-url --push origin "${CI_PUSH_REPO}"
  # added git settings
  - git config --global user.name "Gitlab Runner"
  - git config --global user.email "runner@gitlab.com"
  script:
  - git checkout master
  - git submodule update --recursive --remote
  - git add --all
  - git commit -m "Automatically updated submodule(s)" || echo "" > /dev/null
  - git push
  only:
  - schedules
  - triggers

test:
  stage: test
  image: node
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  before_script:
  - npm install
  script:
  - npm test
  except:
  - schedules
  - triggers

updateSuperProject:
  stage: updateSuper
  script:
  - "curl -X POST -F token=ff47d9bb33fcbf9f2ffe63310cdf79 -F ref=master https://gitlab.com/api/v4/projects/9008132/trigger/pipeline"
  only:
  - master
  except:
  - schedules
  - triggers
